С ИСПОЛЬЗОВАНИЕМ ОФИЦИАЛЬНОГО РАСПРЕДЕЛЕНИЯ ДАЙТЕ СЦЕНАРИЙ МИГРАЦИИ

migrate2rocky.sh -r

Затем это не удалось, и я не могу вернуться к CentOS, потому что дистрибутив больше не имеет версии.

Я попытался перестроить базу dnf после запуска неудачного сценария переноса (CentOS 8)

Он запустился, но затем произошел сбой с "Невозможно определить версию выпуска (используйте '--releasever', чтобы указать версию выпуска)"

Я видел, что выпуск os и redhat очищен до "", ничего.

Я должен попытаться сделать версию обнаруживаемой снова, чтобы запустить обновление dnf makecache и dnf, чтобы исправить все это, но это невозможно сделать, см. Ниже

обнаружена первая ошибка dnf

yum repolist list
Unable to detect release version (use '--releasever' to specify release version)

проблемы с dnf

dnf makecache
Unable to detect release version (use '--releasever' to specify release version)
Extra Packages for Enterprise Linux Modular $releasever - x86_64                                                                                              127 kB/s |  76 kB     00:00    
Errors during downloading metadata for repository 'epel-modular':
  - Status code: 404 for https://mirrors.fedoraproject.org/metalink?repo=epel-modular-$releasever&arch=x86_64&infra=$infra&content=$contentdir (IP: 2a05:d014:10:7803:f774:4d7c:e277:a457)
  - Status code: 404 for https://mirrors.fedoraproject.org/metalink?repo=epel-modular-$releasever&arch=x86_64&infra=$infra&content=$contentdir (IP: 2a05:d01c:c6a:cc01:269:da52:9ae1:43e6)
Error: Failed to download metadata for repo 'epel-modular': Cannot prepare internal mirrorlist: Status code: 404 for https://mirrors.fedoraproject.org/metalink?repo=epel-modular-$releasever&arch=x86_64&infra=$infra&content=$contentdir (IP: 2a05:d014:10:7803:f774:4d7c:e277:a457)

затем последовал процесс переноса:

wget https://raw.githubusercontent.com/rocky-linux/rocky-tools/main/migrate2rocky/migrate2rocky.sh
--2021-08-16 20:03:42--  https://raw.githubusercontent.com/rocky-linux/rocky-tools/main/migrate2rocky/migrate2rocky.sh
Résolution de raw.githubusercontent.com (raw.githubusercontent.com)… 185.199.110.133, 185.199.109.133, 185.199.108.133, ...
Connexion à raw.githubusercontent.com (raw.githubusercontent.com)|185.199.110.133|:443… connecté.
requête HTTP transmise, en attente de la réponse… 200 OK
Taille : 37406 (37K) [text/plain]
Sauvegarde en : « migrate2rocky.sh.2 »

migrate2rocky.sh.2                              100%[=====================================================================================================>]  36,53K  --.-KB/s    ds 0,01s   

2021-08-16 20:03:42 (2,83 MB/s) — « migrate2rocky.sh.2 » sauvegardé [37406/37406]
bash ./migrate2rocky.sh -r

Цель: получить рабочий CentOS8 без переустановки всего

-3
francois P 17 Авг 2021 в 13:20

1 ответ

Лучший ответ

Вот все, что я сделал, чтобы восстановить файлы/переменные версии dnf/yum и базовой версии ОС:

wget http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/dnf-4.4.2-11.el8.noarch.rpm
rpm -ivh ./dnf-4.4.2-11.el8.noarch.rpm  --force
dnf update

По-прежнему возникают ошибки при управлении пакетами дистрибутива, а dnf по-прежнему не работает

Поэтому я получаю минимальные пакеты:

wget http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/centos-linux-release-8.4-1.2105.el8.noarch.rpm
wget http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/centos-linux-repos-8-2.el8.noarch.rpm
rpm -ivh ./centos-linux-release-8.4-1.2105.el8.noarch.rpm ./centos-linux-repos-8-2.el8.noarch.rpm   --force

Не могу их установить, потому что нужен ключ gpg, поэтому

wget http://mirror.centos.org/centos/8/BaseOS/x86_64/os/Packages/centos-gpg-keys-8-2.el8.noarch.rpm
rpm -ivh ./centos-gpg-keys-8-2.el8.noarch.rpm  --force

Затем можно попробовать снова установить основные пакеты

rpm -ivh ./centos-linux-release-8.4-1.2105.el8.noarch.rpm ./centos-linux-repos-8-2.el8.noarch.rpm   --force
dnf makecache
dnf update
rpm --initdb
dnf install epel-release -y # not sure this step was needed

Затем я перезагрузился и вернулся к полностью работающей CentOS-8.

ПРИМЕЧАНИЕ. Я попытался снова запустить скрипт migrate2rocky.sh из его официального (дистрибутив Rocky) git.

Running dnf update before we attempt the migration.
Last metadata expiration check: 0:00:47 ago on Mon Aug 16 20:44:42 2021.
Dependencies resolved.
Nothing to do.
Complete!
rpm: no packages given for erase

Could not remove packages from the rpm db: 

An error occurred while we were attempting to convert your system to Rocky Linux. Your system may be unstable. Script will now exit to prevent possible damage.

 A log of this installation can be found at /var/log/migrate2rocky.log

Шаг

Зато теперь ничего не ломается

Затем я открыл тикет на разработку скрипта дистрибутива для git of rocky distrib


Хорошо, а затем снова, чтобы ответить на окончательное решение здесь

1648/1653): rocky-logos-84.5-8.el8.x86_64.rpm  8.2 MB/s | 328 kB     00:00    
(1649/1653): rocky-backgrounds-84.5-8.el8.noarc 2.3 MB/s | 330 kB     00:00    
(1650/1653): libsndfile-1.0.28-10.el8_4.1.i686. 2.9 MB/s | 217 kB     00:00    
(1651/1653): rpmfusion-nonfree-appstream-data-8 469 kB/s |  39 kB     00:00    
(1652/1653): libsndfile-1.0.28-10.el8_4.1.x86_6 8.9 MB/s | 192 kB     00:00    
(1653/1653): rpmfusion-free-appstream-data-8-1. 502 kB/s |  69 kB     00:00    
--------------------------------------------------------------------------------
Total                                            25 MB/s | 1.6 GB     01:04     
Running transaction check
Error: transaction check vs depsolve:
libdbusmenu(x86-32) = 16.04.0-4.el7 is needed by (installed) libdbusmenu-gtk2-16.04.0-4.el7.i686
To diagnose the problem, try running: 'rpm -Va --nofiles --nodigest'.
You probably have corrupted RPMDB, running 'rpm --rebuilddb' might fix the issue.
The downloaded packages were saved in cache until the next successful transaction.
You can remove cached packages by executing 'dnf clean packages'.

Error during distro-sync.

An error occurred while we were attempting to convert your system to Rocky Linux. Your system may be unstable. Script will now exit to prevent possible damage.

 A log of this installation can be found at /var/log/migrate2rocky.log

Здесь, похоже, проблема с конкретным пакетом, поэтому я перестраиваю работающий Centos

[root@BSU ~]# rpm -ivh --nodeps  centos-linux-repos-8-2.el8.noarch.rpm --force
Verifying...                          ################################# [100%]
Préparation...                       ################################# [100%]
Mise à jour / installation...
   1:centos-linux-repos-8-2.el8       ################################# [100%]
[root@BSU ~]# rpm --force --nodeps -ivh     'http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-linux-release-8.3-1.2011.el8.noarch.rpm'     'http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-gpg-keys-8-2.el8.noarch.rpm'     'http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-linux-repos-8-2.el8.noarch.rpm'  'http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-data-4.4.2-11.el8.noarch.rpm' 'http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-4.4.2-11.el8.noarch.rpm' 'http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-data-4.4.2-11.el8.noarch.rpm' 
Récupération de http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-linux-release-8.3-1.2011.el8.noarch.rpm
Récupération de http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-gpg-keys-8-2.el8.noarch.rpm
Récupération de http://mirror.centos.org/centos/8.3.2011/BaseOS/x86_64/os/Packages/centos-linux-repos-8-2.el8.noarch.rpm
Récupération de http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-data-4.4.2-11.el8.noarch.rpm
Récupération de http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-4.4.2-11.el8.noarch.rpm
Récupération de http://mirror.centos.org/centos/8.4.2105/BaseOS/x86_64/os/Packages/dnf-data-4.4.2-11.el8.noarch.rpm
attention : le paquet dnf-data-4.4.2-11.el8.noarch a déjà été rajouté, dnf-data-4.4.2-11.el8.noarch ignoré
Verifying...                          ################################# [100%]
Préparation...                       ################################# [100%]
Mise à jour / installation...
   1:centos-gpg-keys-1:8-2.el8        ################################# [ 20%]
   2:centos-linux-repos-8-2.el8       ################################# [ 40%]
   3:centos-linux-release-8.3-1.2011.e################################# [ 60%]
   4:dnf-4.4.2-11.el8                 ################################# [ 80%]
   5:dnf-data-4.4.2-11.el8            ################################# [100%]
[root@BSU ~]# dnf makecache 
CentOS Linux 8 - AppStream                                                                                                                                     14 MB/s | 8.8 MB     00:00    
CentOS Linux 8 - BaseOS                                                                                                                                        24 MB/s | 5.6 MB     00:00    
CentOS Linux 8 - Extras                                                                                                                                       8.2 kB/s |  10 kB     00:01    
Extra Packages for Enterprise Linux Modular 8 - x86_64                                                                                                        2.9 MB/s | 931 kB     00:00    
Extra Packages for Enterprise Linux 8 - x86_64                                                                                                                 19 MB/s |  10 MB     00:00    
RPM Fusion for EL 8 - Free - Updates                                                                                                                           20 kB/s | 3.7 kB     00:00    
RPM Fusion for EL 8 - Nonfree - Updates                                                                                                                        35 kB/s | 3.7 kB     00:00    
Cache des métadonnées créé.
[root@BSU ~]# dnf search libdbusmenu
Dernière vérification de l’expiration des métadonnées effectuée il y a 0:00:36 le ven. 27 août 2021 11:51:18 CEST.
========================================================================= Nom correspond exactement à : libdbusmenu ==========================================================================
libdbusmenu.x86_64 : Library for passing menus over DBus
libdbusmenu.i686 : Library for passing menus over DBus
=============================================================================== Nom correspond à : libdbusmenu ===============================================================================
libdbusmenu-gtk2.i686 : Library for passing menus over DBus - Development files - GTK+2 version
libdbusmenu-gtk3.i686 : Library for passing menus over DBus - Development files - GTK+3 version
libdbusmenu-gtk3.x86_64 : Library for passing menus over DBus - Development files - GTK+3 version
[root@BSU ~]# dnf remove libdbusmenu-gtk2.i686
Dépendances résolues.
==============================================================================================================================================================================================
 Paquet                                             Architecture                           Version                                            Dépôt                                     Taille
==============================================================================================================================================================================================
Suppression:
 libdbusmenu-gtk2                                   i686                                   16.04.0-4.el7                                      @System                                    80 k

Résumé de la transaction
==============================================================================================================================================================================================
Supprimer  1 Paquet

Espace libéré : 80 k
Voulez-vous continuer ? [o/N] : o
Test de la transaction
La vérification de la transaction a réussi.
Lancement de la transaction de test
Transaction de test réussie.
Exécution de la transaction
  Préparation           :                                                                                                                                                                 1/1 
  Suppression de        : libdbusmenu-gtk2-16.04.0-4.el7.i686                                                                                                                             1/1 
  Exécution du scriptlet: libdbusmenu-gtk2-16.04.0-4.el7.i686                                                                                                                             1/1 
  Vérification de       : libdbusmenu-gtk2-16.04.0-4.el7.i686                                                                                                                             1/1 
Installed products updated.

Supprimé:
  libdbusmenu-gtk2-16.04.0-4.el7.i686                                                                                                                                                         

Terminé !
[root@BSU ~]# 

Я действительно думаю, что это историческое и больше не нужно, поэтому я удалил его.

Затем я снова запускаю migration2rocky -r и, кажется, все в порядке; просто ждал, когда это закончится, но сейчас все идет хорошо.

Основная проблема связана с неавтоматическим обнаружением epel-next-release.

Последняя проблема касалась локального конкретного пакета, который необходимо удалить, затем перестроить дистрибутив и повторно запустить процесс переноса в последний раз.

Последнее действие Сделать мерж-реквест в дистрибутиве

-1
francois P 27 Авг 2021 в 14:00